# coding: utf-8

"""
    Isilon SDK

    Isilon SDK - Language bindings for the OneFS API  # noqa: E501

    OpenAPI spec version: 4
    Contact: sdk@isilon.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from isi_sdk_8_0_1.api_client import ApiClient


class SnapshotChangelistsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_changelist_lin(self, changelist_lin_id, changelist, **kwargs):  # noqa: E501
        """get_changelist_lin  # noqa: E501

        Get a single entry from the changelist.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_changelist_lin(changelist_lin_id, changelist, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int changelist_lin_id: Get a single entry from the changelist. (required)
        :param str changelist: (required)
        :return: ChangelistLins
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_changelist_lin_with_http_info(changelist_lin_id, changelist, **kwargs)  # noqa: E501
        else:
            (data) = self.get_changelist_lin_with_http_info(changelist_lin_id, changelist, **kwargs)  # noqa: E501
            return data

    def get_changelist_lin_with_http_info(self, changelist_lin_id, changelist, **kwargs):  # noqa: E501
        """get_changelist_lin  # noqa: E501

        Get a single entry from the changelist.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_changelist_lin_with_http_info(changelist_lin_id, changelist, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int changelist_lin_id: Get a single entry from the changelist. (required)
        :param str changelist: (required)
        :return: ChangelistLins
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['changelist_lin_id', 'changelist']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_changelist_lin" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'changelist_lin_id' is set
        if ('changelist_lin_id' not in params or
                params['changelist_lin_id'] is None):
            raise ValueError("Missing the required parameter `changelist_lin_id` when calling `get_changelist_lin`")  # noqa: E501
        # verify the required parameter 'changelist' is set
        if ('changelist' not in params or
                params['changelist'] is None):
            raise ValueError("Missing the required parameter `changelist` when calling `get_changelist_lin`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'changelist_lin_id' in params:
            path_params['ChangelistLinId'] = params['changelist_lin_id']  # noqa: E501
        if 'changelist' in params:
            path_params['Changelist'] = params['changelist']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/platform/1/snapshot/changelists/{Changelist}/lins/{ChangelistLinId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ChangelistLins',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_changelist_lins(self, changelist, **kwargs):  # noqa: E501
        """get_changelist_lins  # noqa: E501

        Get entries from a changelist.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_changelist_lins(changelist, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str changelist: (required)
        :return: ChangelistLinsExtended
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_changelist_lins_with_http_info(changelist, **kwargs)  # noqa: E501
        else:
            (data) = self.get_changelist_lins_with_http_info(changelist, **kwargs)  # noqa: E501
            return data

    def get_changelist_lins_with_http_info(self, changelist, **kwargs):  # noqa: E501
        """get_changelist_lins  # noqa: E501

        Get entries from a changelist.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_changelist_lins_with_http_info(changelist, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str changelist: (required)
        :return: ChangelistLinsExtended
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['changelist']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_changelist_lins" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'changelist' is set
        if ('changelist' not in params or
                params['changelist'] is None):
            raise ValueError("Missing the required parameter `changelist` when calling `get_changelist_lins`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'changelist' in params:
            path_params['Changelist'] = params['changelist']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/platform/1/snapshot/changelists/{Changelist}/lins', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ChangelistLinsExtended',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
